library ieee; use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity lab1 is

generic(width: integer :=4);

port(
clk: 	in std_logic;
rst:	in std_logic;
brst: 	in std_logic;
rdy: 	in std_logic;
rw:	in std_logic;
bus_id:	in std_logic_vector(7 downto 0);
addr:	in std_logic_vector(width - 1 downto 0);
data:   inout std_logic_vector(width - 1 downto 0));

end lab1;

architecture structural of lab1 is

component memCont is
port(
clk: 	in std_logic;
rst:	in std_logic;
brst: 	in std_logic;
rdy: 	in std_logic;
rw:	in std_logic;
bus_id:	in std_logic_vector(7 downto 0);
oe:	out std_logic;
we:	out std_logic;
addr1:	out std_logic;
addr2:	out std_logic);
end component;

component mem is
port(
oe:	in std_logic;
we:	in std_logic;
addr1:	in std_logic;
addr2:	in std_logic;
addr:	in std_logic_vector(width - 1 downto 0);
data:   inout std_logic_vector(width - 1 downto 0));
end component;

signal w1,w2,w3,w4: std_logic;

begin 

MemoryController: memCont port map(clk, rst, brst, rdy, rw, bus_id, w1, w2, w3, w4);
Memory: mem port map(w1, w2, w3, w4, addr, data);

end structural;
