library ieee; use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity mem is

generic(width: integer :=4);

port(
oe:	in std_logic;
we:	in std_logic;
addr1:	in std_logic;
addr2:	in std_logic;
addr:	in std_logic_vector(width - 1 downto 0);
data:   inout std_logic_vector(width - 1 downto 0));

end mem;

architecture behavioral of mem is

type ram is array(0 to 2**width - 1) of std_logic_vector(width - 1 downto 0);
signal tmp_ram: ram := (others => (others => '0'));

begin

comb: process(oe, we, addr1, addr2, addr, data)
begin
data <= (others => 'Z');
if (oe = '1') then
  data <= tmp_ram(conv_integer(addr + (addr2 & addr1)));
elsif (we = '1') then
  tmp_ram(conv_integer(addr)) <= data;
end if;
end process;
end behavioral;
