library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

entity test is
end test;

architecture stimulus of test is

component lab1 is
port(
clk: 	in std_logic;
rst:	in std_logic;
brst: 	in std_logic;
rdy: 	in std_logic;
rw:	in std_logic;
bus_id:	in std_logic_vector(7 downto 0);
addr:	in std_logic_vector(3 downto 0);
data:   inout std_logic_vector(3 downto 0));
end component;

signal tclk: 	std_logic;
signal trst:	std_logic;
signal tbrst: 	std_logic;
signal trdy: 	std_logic;
signal trw:	std_logic;
signal tbus_id:	std_logic_vector(7 downto 0);
signal taddr:	std_logic_vector(3 downto 0);
signal tdata:   std_logic_vector(3 downto 0);

begin

DUT: lab1 port map(tclk, trst, tbrst, trdy, trw, tbus_id, taddr, tdata);

process
begin
tclk <= '0'; wait for 50 ns;
tclk <= '1'; wait for 50 ns;
end process;

process
begin
-- Set initial values and put in reset
taddr <= "1111";
tdata <= "0000";
tbus_id <= "11110011";
tbrst <= '0';
trst <= '1';
trdy <= '0';
trw <= '1'; wait for 500 ns;

-- Take out of reset
trst <= '0'; wait for 100 ns;

-- Write 1111 into addr 0000
trdy <= '1'; 
wait for 100 ns;
trdy <= '0';
trw <= '0';
wait for 100 ns;
tdata <= "1111";
taddr <= "0000";
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
trw <= '1';
wait for 100 ns;

-- Write 1110 into addr 0001
trdy <= '1'; 
wait for 100 ns;
trdy <= '0';
trw <= '0';
wait for 100 ns;
tdata <= "1110";
taddr <= "0001";
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
trw <= '1';
wait for 100 ns;

-- Write 1101 into addr 0010
trdy <= '1'; 
wait for 100 ns;
trdy <= '0';
trw <= '0';
wait for 100 ns;
tdata <= "1101";
taddr <= "0010";
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
trw <= '1';
wait for 100 ns;

-- Write 1100 into addr 0011
trdy <= '1'; 
wait for 100 ns;
trdy <= '0';
trw <= '0';
wait for 100 ns;
tdata <= "1100";
taddr <= "0011";
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
trw <= '1';
wait for 100 ns;

-- Write 1011 into addr 0100
trdy <= '1'; 
wait for 100 ns;
trdy <= '0';
trw <= '0';
wait for 100 ns;
tdata <= "1011";
taddr <= "0100";
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
trw <= '1';
wait for 100 ns;

-- Write 1010 into addr 0101
trdy <= '1'; 
wait for 100 ns;
trdy <= '0';
trw <= '0';
wait for 100 ns;
tdata <= "1010";
taddr <= "0101";
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
trw <= '1';
wait for 100 ns;

-- Write 1001 into addr 0110
trdy <= '1'; 
wait for 100 ns;
trdy <= '0';
trw <= '0';
wait for 100 ns;
tdata <= "1001";
taddr <= "0110";
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
trw <= '1';
wait for 100 ns;

-- Write 1000 into addr 0111
trdy <= '1'; 
wait for 100 ns;
trdy <= '0';
trw <= '0';
wait for 100 ns;
tdata <= "1000";
taddr <= "0111";
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
trw <= '1';
wait for 100 ns;

-- Write 0111 into addr 1000
trdy <= '1'; 
wait for 100 ns;
trdy <= '0';
trw <= '0';
wait for 100 ns;
tdata <= "0111";
taddr <= "1000";
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
trw <= '1';
wait for 100 ns;

-- Write 0110 into addr 1001
trdy <= '1'; 
wait for 100 ns;
trdy <= '0';
trw <= '0';
wait for 100 ns;
tdata <= "0110";
taddr <= "1001";
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
trw <= '1';
wait for 100 ns;

-- Write 0101 into addr 1010
trdy <= '1'; 
wait for 100 ns;
trdy <= '0';
trw <= '0';
wait for 100 ns;
tdata <= "0101";
taddr <= "1010";
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
trw <= '1';
wait for 100 ns;

-- Write 0100 into addr 1011
trdy <= '1'; 
wait for 100 ns;
trdy <= '0';
trw <= '0';
wait for 100 ns;
tdata <= "0100";
taddr <= "1011";
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
trw <= '1';
wait for 100 ns;

-- Write 0011 into addr 1100
trdy <= '1'; 
wait for 100 ns;
trdy <= '0';
trw <= '0';
wait for 100 ns;
tdata <= "0011";
taddr <= "1100";
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
trw <= '1';
wait for 100 ns;

-- Write 0010 into addr 1101
trdy <= '1'; 
wait for 100 ns;
trdy <= '0';
trw <= '0';
wait for 100 ns;
tdata <= "0010";
taddr <= "1101";
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
trw <= '1';
wait for 100 ns;

-- Write 0001 into addr 1110
trdy <= '1'; 
wait for 100 ns;
trdy <= '0';
trw <= '0';
wait for 100 ns;
tdata <= "0001";
taddr <= "1110";
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
trw <= '1';
wait for 100 ns;

-- Write 0000 into addr 1111
trdy <= '1'; 
wait for 100 ns;
trdy <= '0';
trw <= '0';
wait for 100 ns;
tdata <= "0000";
taddr <= "1111";
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
wait for 100 ns;

-- Read from addr 1001
tdata <= (others => 'Z');
trdy <= '1';
wait for 100 ns;
trw <= '1';
wait for 100 ns;
taddr <= "1001";
trdy <= '0';
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
wait for 100 ns;

-- Read from addr 1110
trdy <= '1';
wait for 100 ns;
trw <= '1';
wait for 100 ns;
taddr <= "1110";
trdy <= '0';
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
wait for 100 ns;

-- Read from addr 0101
trdy <= '1';
wait for 100 ns;
trw <= '1';
wait for 100 ns;
taddr <= "0101";
trdy <= '0';
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
wait for 100 ns;

-- Burst Read starting at addr 0111 - 1010
trdy <= '1';
wait for 100 ns;
trw <= '1';
wait for 100 ns;
taddr <= "0111";
trdy <= '0';
wait for 100 ns;
tbrst <= '1';
trdy <= '1';
wait for 100 ns;
trdy <= '0';
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
tbrst <= '0';
trdy <= '0';

-- Burst Read starting at addr 0000 - 0100
trdy <= '1';
wait for 100 ns;
trw <= '1';
wait for 100 ns;
taddr <= "0000";
trdy <= '0';
wait for 100 ns;
tbrst <= '1';
trdy <= '1';
wait for 100 ns;
trdy <= '0';
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
tbrst <= '0';
trdy <= '0';

-- Changing bus_id and attempting 
-- to Read from addr 1000
tbus_id <= "11001010";
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trw <= '1';
wait for 100 ns;
taddr <= "1000";
trdy <= '0';
wait for 100 ns;
trdy <= '1';
wait for 100 ns;
trdy <= '0';
wait for 100 ns;

-- Trigger end of TB
assert false report "NONE. End of simulation." severity failure;

end process;
end stimulus;

configuration CFG_TEST of test is
        for stimulus
                for DUT : lab1 
                end for;
        end for;
end;
